#include <FastLED.h>
#define DATA_PIN 12
#define  LED_COUNT 104

#define COLOR_ORDER GRB

#define wait_time 100

int buttonPin = 2;     // the pin that the pushbutton is attached to
int buttonState = 0;
int countPressed = 0;
bool changeLights = true;

CRGB leds[LED_COUNT];

void setup() {
  FastLED.addLeds<WS2812, DATA_PIN, GRB>(leds, LED_COUNT);
  pinMode(buttonPin, INPUT);
  digitalWrite(buttonPin, HIGH);
  Serial.begin(9600);      // open the serial port at 9600 bps:

}

void freezeColour() {
/*  Serial.print("freezeLoop "); Serial.print("changeLights "); Serial.print(changeLights), Serial.print(" buttonState "); Serial.println(buttonState);
  do {
    buttonState = digitalRead(buttonPin);
    if (buttonState == LOW) {
      changeLights = !changeLights;
      countPressed += 1;
      if ( countPressed % 3 == 0 ) {
        countPressed = 0;
        FastLED.clear();
        FastLED.show();
      }
      delay(1000);
    }

    if (!changeLights) Serial.println("PAUSED");
  } while (!changeLights); */
} 

void loop() {

  //start from red
  for ( int colorStep = 0; colorStep <= 255; colorStep++ ) {

    int r = 255;
    int g = 0;
    int b = colorStep;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    FastLED.show();
  }

  //into blue
  for ( int colorStep = 255; colorStep >= 0; colorStep-- ) {

    int r = colorStep;
    int g = 0;
    int b = 255;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    FastLED.show();
  }

  //start from blue
  for ( int colorStep = 0; colorStep <= 255; colorStep++ ) {

    int r = 0;
    int g = colorStep;
    int b = 255;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    FastLED.show();
  }

  //into green
  for ( int colorStep = 255; colorStep >= 0; colorStep-- ) {

    int r = 0;
    int g = 255;
    int b = colorStep;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    LEDS.show();
  }

  //start from green
  for ( int colorStep = 0; colorStep <= 255; colorStep++ ) {

    int r = colorStep;
    int g = 255;
    int b = 0;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    LEDS.show();
  }
  //into yellow
  for ( int colorStep = 255; colorStep >= 0; colorStep-- ) {

    int r = 255;
    int g = colorStep;
    int b = 0;

    // Now loop though each of the LEDs and set each one to the current color
    for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b); freezeColour();
    }

    // Display the colors we just set on the actual LEDs
    delay(wait_time);
    LEDS.show();
  }



} //end main loop
